'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _pathHelpers = require('../helpers/pathHelpers');

var _CheckboxInput = require('../../styles/cspace-input/CheckboxInput.css');

var _CheckboxInput2 = _interopRequireDefault(_CheckboxInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  className: _propTypes2.default.string,
  /* eslint-disable react/no-unused-prop-types */
  name: _propTypes2.default.string,
  parentPath: _pathHelpers.pathPropType,
  subpath: _pathHelpers.pathPropType,
  /* eslint-enable react/no-unused-prop-types */
  readOnly: _propTypes2.default.bool,
  tristate: _propTypes2.default.bool,
  value: _propTypes2.default.any,
  onCommit: _propTypes2.default.func,
  onClick: _propTypes2.default.func
};

var CheckboxInput = function (_Component) {
  _inherits(CheckboxInput, _Component);

  function CheckboxInput() {
    _classCallCheck(this, CheckboxInput);

    var _this = _possibleConstructorReturn(this, (CheckboxInput.__proto__ || Object.getPrototypeOf(CheckboxInput)).call(this));

    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  _createClass(CheckboxInput, [{
    key: 'handleChange',
    value: function handleChange() {
      var _props = this.props,
          tristate = _props.tristate,
          value = _props.value,
          onCommit = _props.onCommit;


      if (onCommit) {
        var newValue = void 0;

        if (tristate) {
          if (value === false) {
            // Unchecked goes to checked.

            newValue = true;
          } else {
            // Checked and indeterminate go to false.

            newValue = false;
          }
        } else {
          newValue = !value;
        }

        onCommit((0, _pathHelpers.getPath)(this.props), newValue);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          readOnly = _props2.readOnly,
          tristate = _props2.tristate,
          value = _props2.value,
          onClick = _props2.onClick;


      var checked = void 0;
      var classes = (0, _classnames2.default)(readOnly ? _CheckboxInput2.default.readOnly : _CheckboxInput2.default.normal, className);

      if (tristate) {
        if (value === true) {
          checked = true;
        } else if (value === false) {
          checked = false;
        } else {
          checked = false;
          classes = (0, _classnames2.default)(classes, _CheckboxInput2.default.indeterminate);
        }
      } else {
        checked = !!value;
      }

      // FIXME: Don't break these lint rules.

      /* eslint-disable jsx-a11y/label-has-for, jsx-a11y/no-static-element-interactions */
      return _react2.default.createElement(
        'label',
        { className: classes, onClick: onClick },
        _react2.default.createElement('input', {
          checked: checked,
          disabled: readOnly,
          type: 'checkbox',
          onChange: this.handleChange
        }),
        _react2.default.createElement('span', null)
      );
      /* eslint-enable jsx-a11y/label-has-for, jsx-a11y/no-static-element-interactions */
    }
  }]);

  return CheckboxInput;
}(_react.Component);

exports.default = CheckboxInput;


CheckboxInput.propTypes = propTypes;