'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = InputTable;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _InputTableHeader = require('./InputTableHeader');

var _InputTableHeader2 = _interopRequireDefault(_InputTableHeader);

var _InputTableRow = require('./InputTableRow');

var _InputTableRow2 = _interopRequireDefault(_InputTableRow);

var _InputTable = require('../../styles/cspace-input/InputTable.css');

var _InputTable2 = _interopRequireDefault(_InputTable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  children: _propTypes2.default.node,
  embedded: _propTypes2.default.bool,
  renderLabel: _propTypes2.default.func
};

function InputTable(props) {
  var children = props.children,
      embedded = props.embedded,
      renderLabel = props.renderLabel;


  return _react2.default.createElement(
    'div',
    { className: _InputTable2.default.common },
    _react2.default.createElement(
      _InputTableHeader2.default,
      { embedded: embedded, renderLabel: renderLabel },
      children
    ),
    _react2.default.createElement(
      _InputTableRow2.default,
      { embedded: embedded },
      children
    )
  );
}

InputTable.propTypes = propTypes;