'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FilteringDropdownMenuInput = require('./FilteringDropdownMenuInput');

var _FilteringDropdownMenuInput2 = _interopRequireDefault(_FilteringDropdownMenuInput);

var _optionHelpers = require('../helpers/optionHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = _FilteringDropdownMenuInput2.default.propTypes;

var PrefixFilteringDropdownMenuInput = function (_Component) {
  _inherits(PrefixFilteringDropdownMenuInput, _Component);

  function PrefixFilteringDropdownMenuInput(props) {
    _classCallCheck(this, PrefixFilteringDropdownMenuInput);

    var _this = _possibleConstructorReturn(this, (PrefixFilteringDropdownMenuInput.__proto__ || Object.getPrototypeOf(PrefixFilteringDropdownMenuInput)).call(this, props));

    _this.filter = _this.filter.bind(_this);
    _this.handleDropdownInputCommit = _this.handleDropdownInputCommit.bind(_this);

    var prefix = null;

    _this.state = {
      prefix: prefix,
      filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(props.options, prefix),
      value: props.value
    };
    return _this;
  }

  _createClass(PrefixFilteringDropdownMenuInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(nextProps.options, this.state.prefix),
        value: nextProps.value
      });
    }
  }, {
    key: 'filter',
    value: function filter(prefix) {
      this.setState({
        prefix: prefix,
        filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(this.props.options, prefix)
      });
    }
  }, {
    key: 'handleDropdownInputCommit',
    value: function handleDropdownInputCommit(path, value) {
      var prefix = null;

      this.setState({
        prefix: prefix,
        value: value,
        filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(this.props.options, prefix)
      });

      var onCommit = this.props.onCommit;


      if (onCommit) {
        onCommit(path, value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          options = _props.options,
          remainingProps = _objectWithoutProperties(_props, ['options']);

      var _state = this.state,
          filteredOptions = _state.filteredOptions,
          value = _state.value;


      return _react2.default.createElement(_FilteringDropdownMenuInput2.default, _extends({}, remainingProps, {
        filter: this.filter,
        options: filteredOptions,
        value: value,
        onCommit: this.handleDropdownInputCommit
      }));
    }
  }]);

  return PrefixFilteringDropdownMenuInput;
}(_react.Component);

exports.default = PrefixFilteringDropdownMenuInput;


PrefixFilteringDropdownMenuInput.propTypes = propTypes;