'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = changeable;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * An adapter for onChange events. Returns an enhanced component that handles onChange events fired
 * by the base component, and executes a callback with the new value.
 * @param {string|function} BaseComponent - The component to enhance. This component must accept an
 * onChange prop.
 * @returns {function} The enhanced component, which accepts an onChange prop containing a function
 * to be called with the new value.
 */
function changeable(BaseComponent) {
  var baseComponentName = BaseComponent.displayName || BaseComponent.name || 'Component';

  var propTypes = _extends({}, BaseComponent.propTypes, {
    autoSyncValue: _propTypes2.default.bool,
    onChange: _propTypes2.default.func,
    value: _propTypes2.default.string
  });

  var defaultProps = {
    autoSyncValue: true,
    value: ''
  };

  var Changeable = function (_Component) {
    _inherits(Changeable, _Component);

    function Changeable(props) {
      _classCallCheck(this, Changeable);

      var _this = _possibleConstructorReturn(this, (Changeable.__proto__ || Object.getPrototypeOf(Changeable)).call(this, props));

      _this.state = {
        value: props.value
      };

      _this.handleChange = _this.handleChange.bind(_this);
      return _this;
    }

    _createClass(Changeable, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        this.setState({
          value: nextProps.value
        });
      }
    }, {
      key: 'handleChange',
      value: function handleChange(event) {
        if (event && event.target) {
          var value = event.target.value;

          var _props = this.props,
              onChange = _props.onChange,
              autoSyncValue = _props.autoSyncValue;


          if (autoSyncValue) {
            this.setState({
              value: value
            });
          }

          if (onChange) {
            onChange(value);
          }
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _props2 = this.props,
            autoSyncValue = _props2.autoSyncValue,
            onChange = _props2.onChange,
            remainingProps = _objectWithoutProperties(_props2, ['autoSyncValue', 'onChange']);

        var value = this.state.value;


        return _react2.default.createElement(BaseComponent, _extends({}, remainingProps, {
          value: value,
          onChange: this.handleChange
        }));
      }
    }]);

    return Changeable;
  }(_react.Component);

  Changeable.propTypes = propTypes;
  Changeable.defaultProps = defaultProps;
  Changeable.displayName = 'changeable(' + baseComponentName + ')';

  return Changeable;
}